from PyQt5.QtWidgets import QDialog
from PyQt5.QtGui import QImage, QPixmap
import sys
import cv2
import numpy as np
from UI.Digit import Ui_Digit
from UI.DigitDev import DigitDev
from Train.reco2 import Lenet5Recognizier
import copy



class DigitForm(QDialog):
    def __init__(self):
        super(DigitForm, self).__init__()
        # 加载UI（先设计好）
        # 创建对象
        self.ui = Ui_Digit()
        # 使用setupUi绑定对话框（父窗体）
        # AI识别对象
        self.reco2 = Lenet5Recognizier()
        self.ui.setupUi(self)
        # 创建视频对象
        self.dev = DigitDev()
        self.dev.signal_video.connect(self.show_video)
        self.dev.start()

    # 覆盖QDialog原来两个我们不需要的默认功能
    def keyPressEvent(self, e):
        pass

    def closeEvent(self, e):
        # 完成一些需要的释放工作
        self.dev.close()
        sys.exit(0)

    # UI中的两个槽函数
    def capture_image(self):
        # 抓取图像
        self.capture_data = self.buffer_data
        self.capture_shape = self.buffer_shape
        # 显示抓取的图像
        # byte -> QImage
        h, w, ch = self.capture_shape
        image = QImage(self.capture_data, w, h, w * ch, QImage.Format_RGB888)
        # QImage -> QPixmap
        pixmap = QPixmap.fromImage(image)
        # QPixmap -> QLabel
        self.ui.lbl_image.setPixmap(pixmap)
        self.ui.lbl_image.setScaledContents(True)
        self.ui.lbl_image.pixmap().toImage().save("1.jpg","jpg",-1)



    def image_segmentation(self):
        img = cv2.imread('1.jpg')  # 加载图像
        img2 = copy.deepcopy(img)  # 创建副本用于显示轮廓
        img3 = copy.deepcopy(img)
        img4 = copy.deepcopy(img)
        img5 = copy.deepcopy(img)
        img6 = copy.deepcopy(img)
        img7 = copy.deepcopy(img)
        img8 = copy.deepcopy(img)



        gray = cv2.cvtColor(img, cv2.COLOR_BGR2GRAY)  # 将图像转换为灰度图像
        ret, binary = cv2.threshold(gray, 127, 255, cv2.THRESH_BINARY_INV)  # 阈值处理将灰度图像转换为二值图像（反转）

        # 应用自适应阈值
        # binary = cv2.adaptiveThreshold(gray, 255, cv2.ADAPTIVE_THRESH_MEAN_C, cv2.THRESH_BINARY_INV, 11, 2)
        # 应用Otsu's二值化
        # _, binary = cv2.threshold(gray, 0, 255, cv2.THRESH_BINARY + cv2.THRESH_OTSU)

        # ret, binary = cv2.threshold(gray, 127, 255, cv2.THRESH_BINARY)
        contours, hierarchy = cv2.findContours(binary, cv2.RETR_TREE, cv2.CHAIN_APPROX_SIMPLE)  # 查找图像中的轮廓
        cv2.drawContours(img2, contours, -1, (0, 0, 255), 3)  # 绘制初始轮廓
        # cv2.imshow('2', img2)
        # cv2.waitKey(0)

        area = map(cv2.contourArea, contours)  # 计算每个轮廓的面积
        area_list = list(area)
        area_max = max(area_list)  # 找到最大面积的轮廓
        post = area_list.index(area_max)

        area_list.remove(area_max)  # 找到第二大面积的轮廓
        area_second_max = max(area_list)
        post_second = area_list.index(area_second_max)

        cv2.drawContours(img4, contours, post, (0, 0, 255), 3)  # 绘制只显示最大轮廓的图像
        # cv2.imshow('4', img4)
        # cv2.waitKey(0)

        cimg = np.zeros_like(img)
        cimg1 = np.zeros_like(img)
        cimg[:, :, :] = 255
        cimg1[:, :, 1] = 255  # 绿色通道
        cv2.drawContours(cimg, contours, post, color=(0, 0, 0), thickness=-1)  # 创建只包含最大轮廓的图像
        # cv2.imshow('5', cimg)
        # cv2.waitKey(0)

        final = cv2.bitwise_or(img5, cimg)  # 将原始图像和最大轮廓图像进行逐像素的或操作
        # cv2.imshow('6', final)  # 显示最终结果图像
        # cv2.waitKey(0)
        cv2.imwrite('out1.jpg', final)

        cv2.drawContours(img6, contours, post_second, (0, 0, 255), 3)  # 绘制只显示第二大轮廓的图像
        # cv2.imshow('4', img6)
        # cv2.waitKey(0)

        cimg = np.zeros_like(img)
        cimg1 = np.zeros_like(img)
        cimg[:, :, :] = 255
        cimg1[:, :, 1] = 255  # 绿色通道
        cv2.drawContours(cimg, contours, post_second, color=(0, 0, 0), thickness=-1)  # 创建只包含第二大轮廓的图像
        # cv2.drawContours(cimg1, contours, post_second, color=(0, 0, 0), thickness=-1)  # 创建只包含第二大轮廓的图像
        # cv2.imshow('5', cimg)
        # cv2.waitKey(0)

        final = cv2.bitwise_or(img7, cimg)  # 将原始图像和第二大轮廓图像进行逐像素的或操作
        # final = cv2.bitwise_or(final, cimg1)  # 将原始图像和第二大轮廓图像进行逐像素的或操作
        # cv2.imshow('6', final)  # 显示最终结果图像
        # cv2.waitKey(0)
        cv2.imwrite('out2.jpg', final)
        cv2.destroyAllWindows()





        # pixmap = QPixmap.fromImage(QImage.load('out1.jpg'))
        # self.ui.lbl_res_image1.setPixmap(pixmap)
        # self.ui.lbl_res_image1.setScaledContents(True)
        #
        #
        # pixmap = QPixmap.fromImage(QImage.load('out2.jpg')
        # self.ui.lbl_res_image2.setPixmap(pixmap)
        # self.ui.lbl_res_image2.setScaledContents(True)
        self.ui.lbl_res_image1.setPixmap(QPixmap('out1.jpg'))
        self.ui.lbl_res_image1.setScaledContents(True)  # 自适应QLabel大小


        # self.ui.lbl_top2.setText('22')
        # # self.ui.lbl_top2 = QLabel()
        self.ui.lbl_res_image2.setPixmap(QPixmap('out2.jpg'))
        self.ui.lbl_res_image2.setScaledContents(True)









    def digit_recognize(self):
        x1=self.reco2.reco("out1.jpg")
        x2= self.reco2.reco("out2.jpg")
        self.ui.result1.setText(F"<font size=2 color=red><b><strong>{x1[0][0]}</strong><b></font>")
        self.ui.result1_2.setText(F"<font size=2 color=red><b><strong>{x2[0][0]}</strong><b></font>")
        if(x1[0][0]=="石"and x2[0][0]=="剪"):
            self.ui.lbl_top1.setText(F"<font size=2 color=red><b><strong>{x1[0][0]+x1[0][1]+'赢'}</strong><b></font>")
        elif(x1[0][0]=="剪"and x2[0][0]=="石"):
            self.ui.lbl_top1.setText(F"<font size=2 color=red><b><strong>{x2[0][0]+x2[0][1]+'赢'}</strong><b></font>")
        elif (x1[0][0] == "剪" and  x2[0][0] == "布"):
            self.ui.lbl_top1.setText(F"<font size=2 color=red><b><strong>{x1[0][0]+x1[0][1]+'赢'}</strong><b></font>")
        elif (x1[0][0] == "布" and x2[0][0] == "剪"):
            self.ui.lbl_top1.setText(F"<font size=2 color=red><b><strong>{x2[0][0]+x2[0][1]+'赢'}</strong><b></font>")
        elif (x1[0][0] == "布" and x2[0][0] == "石"):
            self.ui.lbl_top1.setText(F"<font size=2 color=red><b><strong>{x1[0][0]+'赢'}</strong><b></font>")
        elif (x1[0][0] == "石" and x2[0][0] == "布"):
            self.ui.lbl_top1.setText(F"<font size=2 color=red><b><strong>{x2[0][0]+'赢'}</strong><b></font>")
        else:
            self.ui.lbl_top1.setText("平局")







    def show_video(self, h, w, ch, data):
        self.buffer_data = data
        self.buffer_shape = (h, w, ch)
        # byte -> QImage
        image = QImage(data, w, h, w * ch, QImage.Format_RGB888)
        # QImage -> QPixmap
        pixmap = QPixmap.fromImage(image)
        # QPixmap -> QLabel
        self.ui.lbl_video.setPixmap(pixmap)
        self.ui.lbl_video.setScaledContents(True)