import cv2
import numpy as np
import copy

img = cv2.imread('2.jpg')  # 加载图像
img2 = copy.deepcopy(img)  # 创建副本用于显示轮廓
img3 = copy.deepcopy(img)
img4 = copy.deepcopy(img)
img5 = copy.deepcopy(img)
img6 = copy.deepcopy(img)
img7 = copy.deepcopy(img)
img8 = copy.deepcopy(img)

cv2.imshow('1', img)  # 显示原始图像
cv2.waitKey(0)

gray = cv2.cvtColor(img, cv2.COLOR_BGR2GRAY)  # 将图像转换为灰度图像
ret, binary = cv2.threshold(gray, 127, 255, cv2.THRESH_BINARY_INV)  # 阈值处理将灰度图像转换为二值图像（反转）

# 应用自适应阈值
# binary = cv2.adaptiveThreshold(gray, 255, cv2.ADAPTIVE_THRESH_MEAN_C, cv2.THRESH_BINARY_INV, 11, 2)
# 应用Otsu's二值化
# _, binary = cv2.threshold(gray, 0, 255, cv2.THRESH_BINARY + cv2.THRESH_OTSU)


# ret, binary = cv2.threshold(gray, 127, 255, cv2.THRESH_BINARY)
contours, hierarchy = cv2.findContours(binary, cv2.RETR_TREE, cv2.CHAIN_APPROX_SIMPLE)  # 查找图像中的轮廓
cv2.drawContours(img2, contours, -1, (0, 0, 255), 3)  # 绘制初始轮廓
# cv2.imshow('2', img2)
# cv2.waitKey(0)





area = map(cv2.contourArea, contours)  # 计算每个轮廓的面积
area_list = list(area)
area_max = max(area_list)  # 找到最大面积的轮廓
post = area_list.index(area_max)


# 找到当前轮廓的最大坐标点
min_val, max_val, min_loc, max_loc = cv2.minMaxLoc(area_max)
print(min_loc)
print(max_loc)
# 如果当前轮廓的最大坐标值大于已知的最大坐标值，则更新最大坐标值和对应的轮廓
# if max_val > max_point:
#     max_point = max_val
#     max_contour = contour

# 绘制最大坐标点
cv2.circle(img4, max_loc, 5, (0, 0, 255), -1)

area_list.remove(area_max) # 找到第二大面积的轮廓
area_second_max = max(area_list)
post_second = area_list.index(area_second_max)

cv2.drawContours(img4, area_max, post, (0, 0, 255), 3)  # 绘制只显示最大轮廓的图像
# cv2.imshow('4', img4)
# cv2.waitKey(0)

cimg = np.zeros_like(img)
cimg1 = np.zeros_like(img)
cimg[:, :, :] = 255
cimg1[:, :, 1] = 255  # 绿色通道
cv2.drawContours(cimg1, area_max, post, color=(0, 0, 0), thickness=-1)  # 创建只包含最大轮廓的图像
# cv2.imshow('5', cimg)
# cv2.waitKey(0)

final = cv2.bitwise_or(img5, cimg1)  # 将原始图像和最大轮廓图像进行逐像素的或操作
# cv2.imshow('6', final)  # 显示最终结果图像
# cv2.waitKey(0)
cv2.imwrite('output1.jpg', final)


cv2.drawContours(img6, contours, post_second, (0, 0, 255), 3)  # 绘制只显示第二大轮廓的图像
# cv2.imshow('4', img6)
# cv2.waitKey(0)

cimg = np.zeros_like(img)
cimg1 = np.zeros_like(img)
cimg[:, :, :] = 255
cimg1[:, :, 1] = 255  # 绿色通道
cv2.drawContours(cimg, contours, post_second, color=(0, 0, 0), thickness=-1)  # 创建只包含第二大轮廓的图像
cv2.drawContours(cimg1, contours, post_second, color=(0, 0, 0), thickness=-1)  # 创建只包含第二大轮廓的图像
# cv2.imshow('5', cimg)
# cv2.waitKey(0)

final = cv2.bitwise_or(img7, cimg1)  # 将原始图像和第二大轮廓图像进行逐像素的或操作
# final = cv2.bitwise_or(final, cimg1)  # 将原始图像和第二大轮廓图像进行逐像素的或操作
# cv2.imshow('6', final)  # 显示最终结果图像
# cv2.waitKey(0)
cv2.imwrite('output2.jpg', final)
cv2.destroyAllWindows()
